/*  
[INFO] 
NAME=Great Catalog Quick Placer
AUTHOR=Vasyl Lukianenko
DEV=3DGROUND
DEV_WEB=https://3dground.net/
HELP=

[SCRIPT]
*/

try (DestroyDialog quickPlacer) catch ()
global quickPlacer

rollout quickPlacer "Quick Placer" (
	checkbutton btnPlace "" width: 42 height: 42 pos: [15, 5]
	checkbutton btnRotate "" width: 42 height: 42 pos: [62, 5]
	
	checkbutton btnUseX "" width: 42 height: 42 pos: [125, 5]
	checkbutton btnUseY "" width: 42 height: 42 pos: [172, 5]
	checkbutton btnUseZ "" width: 42 height: 42 pos: [219, 5]
	
	fn updateImageButton b id file: "PhysX_Main_24i.bmp" cnt: 33 = (
		local p = getFileNamePath (getThisScriptFileName())
		local i = p + file
		b.images = #(i, undefined, cnt , id, id, id ,id , false, true)
	)
	
	fn setIcon b type: #main id: 1 = (
		local file = case type of (
			#main: "Maintoolbar_24i.bmp"
			#physx: "PhysX_Main_24i.bmp"
		)
		
		local cnt = case type of (
			#main: 107
			#physx: 33
		)
		
		updateImageButton b id file: file cnt: cnt
	)
	
	fn updatePlaceSettings = (
		local p = PlacementTool.ActiveMode
		local r = PlacementTool.RotateMode
		
		btnPlace.checked = p
		btnRotate.checked = p and r
		
		btnUseX.checked = false
		btnUseY.checked = false
		btnUseZ.checked = false
		
		case PlacementTool.UpAxis of (			
			#Positive_X: btnUseX.checked = true
			#Positive_Y: btnUseY.checked = true
			#Positive_Z: btnUseZ.checked = true
		)
	)
	
	on quickPlacer close do (
		callbacks.removeScripts #spacemodeChange id:#QuickPlacer
		PlacementTool.ActiveMode = false
	)
	
	on quickPlacer open do (
		local s = sysInfo.DesktopSize
		local p = GetDialogPos quickPlacer
		
		p.y = s.y - 180
		SetDialogPos quickPlacer p
		
		setIcon btnPlace type: #main id: 104
		setIcon btnRotate type: #main id: 105
		
		setIcon btnUseX type: #main id: 38
		setIcon btnUseY type: #main id: 40
		setIcon btnUseZ type: #main id: 42
		
		PlacementTool.UpAxis = #Positive_Z
		PlacementTool.ActiveMode = true
		PlacementTool.RotateMode = false
		PlacementTool.PillowMode = true
		
		updatePlaceSettings()
		
		callbacks.removeScripts #spacemodeChange id:#QuickPlacer
		callbacks.addScript #spacemodeChange "try(quickPlacer.updatePlaceSettings())catch()" id:#QuickPlacer
	)
	
	on btnPlace changed v do (
		if (PlacementTool.RotateMode) do v = true
		PlacementTool.ActiveMode = v
		PlacementTool.RotateMode = false
		updatePlaceSettings()
	)
	
	on btnRotate changed v do (
		PlacementTool.ActiveMode = true
		PlacementTool.RotateMode = v
		updatePlaceSettings()
	)
	
	on btnUseX changed v do (
		PlacementTool.UpAxis = #Positive_X
		updatePlaceSettings()
	)
	
	on btnUseY changed v do (
		PlacementTool.UpAxis = #Positive_Y
		updatePlaceSettings()
	)
	
	on btnUseZ changed v do (
		PlacementTool.UpAxis = #Positive_Z
		updatePlaceSettings()
	)
)

fn isPlaceModeExist = (
	return (((maxVersion())[1] / 1000) >= 17)
)

if (isPlaceModeExist()) do CreateDialog quickPlacer 276 52
	
(
	tool objectPlacer numPoints:1 (
		local obj = undefined
		local pos = [0, 0, 0]
		
		fn handler s = (
			try (select s) catch ()
			local g = for i in s where i.parent == undefined collect i			
			case of (
				(g.count == 1): return g[1]
				(g.count > 1): return group g name: (uniqueName "Objects Bundle ")
			)
			
			return group s name: (uniqueName "Objects Bundle ")
		)
		
		fn setGroundPos o pos = (
			try (
				o.pos = pos
				o.pos.z = o.pos.z - o.min.z
				return o.pos
			) catch (
				return [0, 0, 0]
			)
		)
		
		on mouseAbort v do (
			setGroundPos obj pos
		)
		
		on start do (
			obj = handler selection
			--try (select obj) catch ()
			
			if (obj == undefined) do (
				stopTool objectPlacer
				return #stop
			)
			
			pos = try (obj.pos) catch ([0, 0, 0])
		)
		
		on freeMove do (			
			setGroundPos obj gridPoint
		)
	)
	
	fn selectAllObject = (
		try (select selection) catch ()
	)
	
	if (selection.count != 0) do (
		selectAllObject()
		startTool objectPlacer
	)
)