struct logGCMergerWrapper (
    fn setTextBoxPadding c p = (
        local h = c.handle
        local EM_SETMARGINS = 0xd3
        local EC_RIGHTMARGIN = 2
        local EC_LEFTMARGIN = 1
        local EC_TOPMARGIN = 0
        windows.SendMessage h EM_SETMARGINS EC_LEFTMARGIN p
        windows.SendMessage h EM_SETMARGINS EC_RIGHTMARGIN (bit.shift p 16)
    ),
    
    fn getDotNetColors = (
        struct dotNetColors (
            fn getClr r g b = (dotnetclass "System.Drawing.Color").FromArgb r g b,
            fn getBg = (
                local bg = if((maxVersion())[1] > 16000) then #rollupTitleFace else #background
                local c = (colorman.getColor bg) * 255
                return getClr c[1] c[2] c[3]
            ),
            fn getFg = (
                local c = (colorman.getColor #rollupTitleText) * 255
                return getClr c[1] c[2] c[3]
            ),
            fn getByName n = (
                local c = try (n as color) catch(color 0 0 0)
                local cc = #(c.r, c.g, c.b)
                local j = for i in cc collect i as integer
                    
                return getClr j[1] j[2] j[3]
            ),
            fn getByRGB r g b = (
                return getClr r g b
            )
        )
        
        return dotNetColors()
    ),
    
    fn initTextBox textBox = (
        local cc = getDotNetColors()
        textBox.Font = dotNetObject "System.Drawing.Font" "MS Sans Serif" 8 ((dotNetClass "System.Drawing.FontStyle").Regular)
        textBox.BorderStyle = (dotNetClass "System.Windows.Forms.BorderStyle").FixedSingle
        textBox.BackColor = cc.getBg()
        textBox.ForeColor = cc.getFg()
        textBox.MultiLine = true
        textBox.WordWrap = true
        textBox.ScrollBars = (dotNetClass "System.Windows.Forms.ScrollBars").Vertical
        textBox.ReadOnly = true
        
        setTextBoxPadding textBox 5
    ),
    
    fn show m title:"Success!" height: 400 width: 415 = (
        try (DestroyDialog rShowLog) catch ()
        global szStat = m
        global iWidth = width - 2
        global iHeight = height - 35
        
        rollout rShowLog title (
            dotNetControl edtStat "System.Windows.Forms.Textbox" width: iWidth height: iHeight align:#center pos: [1, 1]
            
            dotNetControl btnCopyLog "System.Windows.Forms.Button" height: 25 width: 90 align: #left across: 2 
            dotNetControl btnCloseLog "System.Windows.Forms.Button" height: 25 width: 90 align: #right 
            
            fn initDotNet = (
                initTextBox edtStat
                btnCloseLog.text = "Close"
                btnCopyLog.text = "Copy"
                
                btnCloseLog.flatStyle = btnCloseLog.flatStyle.Popup
                btnCopyLog.flatStyle = btnCloseLog.flatStyle.Popup
            )
            
            on btnCloseLog Click do try(DestroyDialog rShowLog)catch()
            on btnCopyLog Click do setClipboardText szStat 
            
            on rShowLog open do (
                initDotNet()
                edtStat.text = szStat
            )
        )
        
        createDialog rShowLog width height modal: true
    )
)