/*  
[INFO] 
NAME=Great Catalog Merger Updater
AUTHOR=Vasyl Lukianenko
DEV=3DGROUND
DEV_WEB=https://3dground.net/
HELP=

[SCRIPT]
*/

struct updateGCMerger (
    currentPath = getFileNamePath (getThisScriptFileName()),
    manifest = currentPath + "manifest.ini",
    macro = this.settings "MACRO",
    cat = this.settings "CAT",
    txt = this.settings "TXT",
    run = this.settings "RUN",
    ver = this.settings "VER",
    check = this.settings "CHECK",
    mzp = this.settings "MZP",
    script = this.currentPath + this.run,
    tempFile = this.currentPath + "temp.tmp",
    tempMzp = this.currentPath + this.macro + ".mzp",
    ftm = dotnetobject "System.Windows.Forms.Timer",
    needUpdate = false,

    fn settings k s: "INDEX" = (
        return getINISetting this.manifest s k
    ),
    
    fn getNotes = (
        return getINISetting this.manifest this.ver
    ),
    
    fn onTimerUpdate s a = (
		local self = s.tag.value
        s.Stop()
        
        if (not self.needUpdate or not doesFileExist self.tempMzp) do return false
        
        local isUnpack = msZip.unloadPackage self.tempMzp &extractDir &dropFile
        deleteFile self.tempMzp
        
        if(isUnpack) do (
            local n = "\r\n"
            local m = n
            
            self.ver = self.settings "VER"
            
            m += "\t==============================================" + n
            m += "\t=====     " + self.txt + " " + self.ver + " updated successfully!" + "      =====" + n
            m += "\t==============================================" + n + n + n
            
            m += "[?] Changelog:" + n
            for i in self.getNotes() do m += " " + i + n
            
            include "log.ms"
            (logGCMergerWrapper()).show m title: "Update"
                
            try (::__ASSETS_LIBRARY_VIEWER.closeForm()) catch ()
            try (fileIn self.script) catch ()
        )
    ),
    
    fn downloadFile url dl = (
        deleteFile dl
        local w = dotNetObject "System.Net.WebClient"
        try (
            spm = dotNetClass "System.Net.ServicePointManager"
            spm.SecurityProtocol = spm.SecurityProtocol.TLS12
            w.DownloadFile (url + "?time=" + timestamp() as string) dl
            
            return dl
        ) catch (
            return false
        )
        
        return false
    ),
    
    fn bgUpdate = (
        local r = this.downloadFile this.check this.tempFile
        if(r == false or not doesFileExist this.tempFile) do return print "Can't download updates!"
        local vn = getIniSetting this.tempFile "INDEX" "VER"
        local vo = this.ver
      
        if(vn > vo) do (
            if (not doesFileExist this.tempMzp) then (
                this.downloadFile this.mzp this.tempMzp
            )
            
            this.needUpdate = true
        )
        
        deleteFile this.tempFile
    ),
    
    fn updateWorker = (
        local m = dotnetobject "CSharpUtilities.SynchronizingBackgroundWorker"
        m.WorkerSupportsCancellation = true 
        m.CancelAsync() 
        dotNet.addEventHandler m "DoWork" this.bgUpdate
        m.RunWorkerAsync()
    ),

    on create do (
        this.ftm.Interval = 2000
		this.ftm.tag = dotNetMxsValue this
        dotNet.setLifetimeControl this.ftm #dotnet
        dotnet.addEventHandler this.ftm "Tick" onTimerUpdate
        
        this.updateWorker()
        this.ftm.Start()
    )
)

updateGCMerger()